import { ErrorResponse, Void } from './types';
type PromiseFnArg = {
    offset: string | number | any;
    limit: string | number | any;
    [k: string]: any;
};
type PromiseFn<T> = Void<(...args: PromiseFnArg[]) => Promise<T> | Promise<[T | undefined, ErrorResponse]>>;
type UseRecursiveFetchParams<R = any> = {
    offset?: string | number;
    limit?: string | number;
    callback?: Void<(data: R[]) => any>;
    finally?: Void<(data: R[]) => any>;
    debug?: boolean;
    until?: (param: Pick<PromiseFnArg, 'offset' | 'limit'> & {
        total: number;
    }) => boolean;
};
type UseRecursiveFetchReturn<A> = [A[], Void<() => void>];
export declare const useRecursiveFetchPaginate: <R = unknown, T = unknown>(promiseFn: (...args: PromiseFnArg[]) => Promise<T> | Promise<[T | undefined, any]>, accessor: string | null, params?: UseRecursiveFetchParams<R> | undefined) => UseRecursiveFetchReturn<R>;
export {};
