"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRecursiveFetchPaginate = void 0;
var react_1 = require("react");
var helpers_1 = require("./helpers");
var useRecursiveFetchPaginate = function (promiseFn, 
// `promiseFn` required limit, offset parameter,
// this will be used to split the data into small pieces
// --
accessor, // Accessor for response
params) {
    var pagination = (0, react_1.useRef)({
        page: 0,
        offset: (params === null || params === void 0 ? void 0 : params.offset) || 0,
        limit: (params === null || params === void 0 ? void 0 : params.limit) || 50,
    });
    var chunksLen = (0, react_1.useRef)(0);
    var stopLoop = (0, react_1.useRef)(false);
    // Used to prevent state update if the component is unmounted
    var cancelRequest = (0, react_1.useRef)(false);
    // Store data in chunks
    var _a = (0, react_1.useState)([]), chunks = _a[0], setChunks = _a[1];
    var fetchData = (0, react_1.useCallback)(function () {
        var recurseFetchCall = function () { return __awaiter(void 0, void 0, void 0, function () {
            var _a, res, resErr, results_1, until, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 3, , 4]);
                        if (params === null || params === void 0 ? void 0 : params.debug) {
                            // eslint-disable-next-line no-console
                            console.debug('(Debug useRecursiveFetchPaginate) State: ', stopLoop.current, pagination.current);
                        }
                        if (!(!cancelRequest.current && !stopLoop.current)) return [3 /*break*/, 2];
                        pagination.current.page++;
                        return [4 /*yield*/, (0, helpers_1.promiseExtractor)(promiseFn({
                                limit: pagination.current.limit,
                                offset: pagination.current.offset,
                            }))
                            // Abort
                        ];
                    case 1:
                        _a = _b.sent(), res = _a[0], resErr = _a[1];
                        // Abort
                        if (resErr) {
                            cancelRequest.current = true;
                        }
                        results_1 = [];
                        // Access response data
                        if (accessor) {
                            results_1 = res === null || res === void 0 ? void 0 : res.data[accessor]; // if accessor undefined, process will stopped
                        }
                        else {
                            results_1 = res === null || res === void 0 ? void 0 : res.data;
                        }
                        until = (params === null || params === void 0 ? void 0 : params.until) &&
                            (params === null || params === void 0 ? void 0 : params.until({
                                limit: pagination.current.limit,
                                offset: pagination.current.offset,
                                total: chunksLen.current,
                            }));
                        // Stop calling itself
                        if (until || results_1.length < pagination.current.limit) {
                            stopLoop.current = true;
                        }
                        if (results_1.length) {
                            (params === null || params === void 0 ? void 0 : params.callback) && params.callback(results_1);
                            setChunks(function (chunk) {
                                var next = __spreadArray([], chunk, true).concat(results_1);
                                return next;
                            });
                            pagination.current.offset =
                                Number(pagination.current.page) * Number(pagination.current.limit);
                            void recurseFetchCall();
                        }
                        _b.label = 2;
                    case 2: return [3 /*break*/, 4];
                    case 3:
                        error_1 = _b.sent();
                        cancelRequest.current = true;
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); };
        void recurseFetchCall();
        // avoid multiple re-rendering (not need callback dependencies)
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [params === null || params === void 0 ? void 0 : params.debug, promiseFn, accessor]);
    (0, react_1.useEffect)(function () {
        chunksLen.current = chunks.length;
        if (stopLoop.current && chunks.length) {
            (params === null || params === void 0 ? void 0 : params.finally) && params.finally(chunks);
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [chunks.length]);
    (0, react_1.useEffect)(function () {
        // Use the cleanup function for avoiding a possibly...
        // ...state update after the component was unmounted
        return function () {
            cancelRequest.current = true;
        };
    }, []);
    return [stopLoop.current && chunks.length ? chunks : [], fetchData];
};
exports.useRecursiveFetchPaginate = useRecursiveFetchPaginate;
//# sourceMappingURL=index.js.map